Unit ZP11R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZRPQLI_p, ZRPQLB_p, UTZP10_p;

procedure ZP11R(NP :Integer; var A :Array of Real;
                var ROOT :Array of Real; var RAB :Array of Real;
                var IERR :Integer);

implementation

procedure ZP11R(NP :Integer; var A :Array of Real;
                var ROOT :Array of Real; var RAB :Array of Real;
                var IERR :Integer);
var
J,JJ,J1,J2,I,I1,I2,ICNT,L,N2,NPI,NZ,NDEG,NDEG2,NM1 :Integer;
AA,BB,BND,CC,COSR,DX,DF,T,YY,FN,FF,FACTOR,SC,SINR,X,XX,XXX,XM,RLO,
   RMAX,RMIN :Real;
ZEROK :Boolean;
const
SYS063 :Real = 2.0;
ZERO :Real = 0.0;
ONE :Real = 1.0;
SYS055 :Real = 1.2E-38;
SYS059 :Real = 3.4E38;  //  Delphi>3
SYS051 :Real = 1.192093E-06;
SYS053 :Real = 1.7E308; //  Delphi>3
SYS029 :Real = 0.70710678118654752440084436210485;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35;
begin
NDEG := NP;
_PRPQLJ.elm25 := NDEG;
_PP11R.elm1 := _PRPQLJ.elm25+1;
_PP11R.elm2 := _PP11R.elm1+_PP11R.elm1;
_PP11R.elm3 := _PP11R.elm2+_PP11R.elm1;
_PP11R.elm4 := _PP11R.elm3+_PP11R.elm1;
_PP11R.elm5 := _PP11R.elm4+_PP11R.elm1;
_PP11R.elm6 := _PP11R.elm5+_PP11R.elm1;
IERR := 0;
if ( NDEG < 1 ) 
 then goto _33;
_PRPQLJ.elm22 := SYS051;
_PRPQLJ.elm23 := _PRPQLJ.elm22;
_PRPQLJ.elm24 := _PRPQLJ.elm22;
RLO := SYS055/_PRPQLJ.elm22;
XX := SYS029;
YY := -XX;
SINR := 0.9975641;
COSR := -0.06975647;
_PRPQLJ.elm26 := _PRPQLJ.elm25+1;
J := 1;
NDEG2 := NDEG+NDEG;
if ( A[_PRPQLJ.elm26-1] <> ZERO ) 
 then goto _1;
IERR := 66;
goto _34;
_1:
if ( A[J-1] <> ZERO ) 
 then goto _2;
ROOT[J-1] := ZERO;
JJ := J+NP;
ROOT[JJ-1] := ZERO;
_PRPQLJ.elm26 := _PRPQLJ.elm26-1;
_PRPQLJ.elm25 := _PRPQLJ.elm25-1;
J := J+1;
if ( J = NP+1 ) 
 then goto _35;
goto _1;
_2:
for I:=1 to _PRPQLJ.elm26 do
 begin
  I1 := _PRPQLJ.elm26-I+_PP11R.elm2+1;
  I2 := I+J-1;
  RAB[I1-1] := A[I2-1];
_3:
 end;
_4:
if ( _PRPQLJ.elm25 > 2 ) 
 then goto _6;
if ( _PRPQLJ.elm25 < 1 ) 
 then goto _35;
if ( _PRPQLJ.elm25 = 2 ) 
 then goto _5;
ROOT[NDEG-1] := -RAB[_PP11R.elm2+1]/RAB[_PP11R.elm2+0];
ROOT[NDEG2-1] := ZERO;
goto _29;
_5:
ZRPQLI(RAB[_PP11R.elm2+0],RAB[_PP11R.elm2+1],RAB[_PP11R.elm2+2],
     ROOT[NDEG-2],ROOT[NDEG2-2],ROOT[NDEG-1],ROOT[NDEG2-1]);
goto _29;
_6:
RMAX := 0.0;
RMIN := SYS053;
for I:=1 to _PRPQLJ.elm26 do
 begin
  I1 := _PP11R.elm2+I;
  X := Abs(RAB[I1-1]);
  if ( X > RMAX ) 
   then RMAX := X;
  if ( X <> 0.0 ) and ( X < RMIN ) 
   then RMIN := X;
_7:
 end;
SC := RLO/RMIN;
if ( SC > 1.0 ) 
 then goto _8;
if ( RMAX < 10.0 ) 
 then goto _11;
if ( SC = 0.0 ) 
 then SC := SYS055*SYS063*SYS063;
goto _9;
_8:
if ( SYS053/SC < RMAX ) 
 then goto _11;
_9:
L := Trunc( Ln(SC)/Ln(SYS063)+0.5 );
if ( L = 0 ) 
 then goto _11;
FACTOR := IntPower(SYS063,L);
for I:=1 to _PRPQLJ.elm26 do
 begin
  I1 := _PP11R.elm2+I;
_10:
  RAB[I1-1] := FACTOR*RAB[I1-1];
 end;
_11:
for I:=1 to _PRPQLJ.elm26 do
 begin
  I1 := _PP11R.elm1+I;
  I2 := _PP11R.elm2+I;
_12:
  RAB[I1-1] := Abs(RAB[I2-1]);
 end;
I1 := _PP11R.elm1+_PRPQLJ.elm26;
RAB[I1-1] := -RAB[I1-1];
X := Exp((Ln(-RAB[I1-1])-Ln(RAB[_PP11R.elm1+0]))/(_PRPQLJ.elm25));
I2 := _PP11R.elm1+_PRPQLJ.elm25;
if ( RAB[I2-1] = 0.0 ) 
 then goto _13;
XM := -RAB[I1-1]/RAB[I2-1];
if ( XM < X ) 
 then X := XM;
_13:
XM := X*0.1;
FF := RAB[_PP11R.elm1+0];
for I:=2 to _PRPQLJ.elm26 do
 begin
  I1 := _PP11R.elm1+I;
_14:
  FF := FF*XM+RAB[I1-1];
 end;
if ( FF <= 0.0 ) 
 then goto _15;
X := XM;
goto _13;
_15:
DX := X;
_16:
if ( Abs(DX/X) <= 0.005 ) 
 then goto _18;
FF := RAB[_PP11R.elm1+0];
DF := FF;
for I:=2 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm1+I;
  FF := FF*X+RAB[I1-1];
  DF := DF*X+FF;
_17:
 end;
I1 := _PP11R.elm1+_PRPQLJ.elm26;
FF := FF*X+RAB[I1-1];
DX := FF/DF;
X := X-DX;
goto _16;
_18:
BND := X;
NM1 := _PRPQLJ.elm25-1;
FN := ONE/(_PRPQLJ.elm25);
for I:=2 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm4+I;
  I2 := _PP11R.elm2+I;
_19:
  RAB[I1-1] := (_PRPQLJ.elm26-I)*RAB[I2-1]*FN;
 end;
RAB[_PP11R.elm4+0] := RAB[_PP11R.elm2+0];
I1 := _PP11R.elm2+_PRPQLJ.elm26;
I2 := _PP11R.elm2+_PRPQLJ.elm25;
AA := RAB[I1-1];
BB := RAB[I2-1];
I1 := _PP11R.elm4+_PRPQLJ.elm25;
ZEROK := ( RAB[I1-1] = ZERO );
for JJ:=1 to 5 do
 begin
  I1 := _PP11R.elm4+_PRPQLJ.elm25;
  CC := RAB[I1-1];
  if ( ZEROK ) 
   then goto _21;
  T := -AA/CC;
  for I:=1 to NM1 do
   begin
    J1 := _PRPQLJ.elm26-I+_PP11R.elm4;
    J2 := _PRPQLJ.elm26-I+_PP11R.elm2;
    RAB[J1-1] := T*RAB[J1-2]+RAB[J2-1];
_20:
   end;
  RAB[_PP11R.elm4+0] := RAB[_PP11R.elm2+0];
  I1 := _PP11R.elm4+_PRPQLJ.elm25;
  ZEROK := ( Abs(RAB[I1-1]) <= Abs(BB)*_PRPQLJ.elm22*10.0 );
  goto _23;
_21:
  for I:=1 to NM1 do
   begin
    J := _PRPQLJ.elm26-I+_PP11R.elm4;
    RAB[J-1] := RAB[J-2];
_22:
   end;
  RAB[_PP11R.elm4+0] := ZERO;
  I1 := _PP11R.elm4+_PRPQLJ.elm25;
  ZEROK := ( RAB[I1-1] = ZERO );
_23:
 end;
for I:=1 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm4+I;
_24:
  RAB[I-1] := RAB[I1-1];
 end;
for ICNT:=1 to 20 do
 begin
  XXX := COSR*XX-SINR*YY;
  YY := SINR*XX+COSR*YY;
  XX := XXX;
  _PRPQLJ.elm1 := BND*XX;
  _PRPQLJ.elm2 := BND*YY;
  _PRPQLJ.elm3 := -_PRPQLJ.elm1-_PRPQLJ.elm1;
  _PRPQLJ.elm4 := BND;
  ZRPQLB(20*ICNT,NZ,RAB);
  if ( NZ = 0 ) 
   then goto _26;
  J := NDEG-_PRPQLJ.elm25+1;
  JJ := J+NDEG;
  ROOT[J-1] := _PRPQLJ.elm18;
  ROOT[JJ-1] := _PRPQLJ.elm19;
  _PRPQLJ.elm26 := _PRPQLJ.elm26-NZ;
  _PRPQLJ.elm25 := _PRPQLJ.elm26-1;
  for I:=1 to _PRPQLJ.elm26 do
   begin
    I1 := _PP11R.elm2+I;
    I2 := _PP11R.elm3+I;
_25:
    RAB[I1-1] := RAB[I2-1];
   end;
  if ( NZ = 1 ) 
   then goto _4;
  ROOT[J+0] := _PRPQLJ.elm20;
  ROOT[JJ+0] := _PRPQLJ.elm21;
  goto _4;
_26:
  for I:=1 to _PRPQLJ.elm25 do
   begin
    I1 := _PP11R.elm4+I;
_27:
    RAB[I1-1] := RAB[I-1];
   end;
_28:
 end;
IERR := 67;
_29:
for I:=1 to NDEG do
 begin
  NPI := NDEG+I;
  I1 := _PP11R.elm2+I;
  RAB[I1-1] := ROOT[NPI-1];
_30:
 end;
N2 := NDEG+NDEG;
J := NDEG;
for I:=1 to NDEG do
 begin
  I1 := _PP11R.elm2+J;
  ROOT[N2-2] := ROOT[J-1];
  ROOT[N2-1] := RAB[I1-1];
  N2 := N2-2;
  J := J-1;
_31:
 end;
if ( IERR = 0 ) 
 then goto _35;
N2 := 2*(NDEG-_PRPQLJ.elm26)+3;
for I:=1 to _PRPQLJ.elm25 do
 begin
  ROOT[N2-1] := SYS059;
  ROOT[N2+0] := SYS059;
  N2 := N2+2;
_32:
 end;
goto _34;
_33:
IERR := 65;
_34:
if ( IERR <> 0 ) 
 then UTZP10(IERR,11);
_35:
end;

end.
