Unit ZRPQLB_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZRPQLH_p, ZRPQLE_p, ZRPQLF_p, ZRPQLG_p, ZRPQLC_p, ZRPQLD_p;

procedure ZRPQLB(L2 :Integer; var NZ :Integer;
                var RAB :Array of Real);

implementation

procedure ZRPQLB(L2 :Integer; var NZ :Integer;
                var RAB :Array of Real);
var
ITYPE,J,I,I1,I2,IFLAG :Integer;
SS,SVU,SVV,UI,VI,VV,BETAV,BETAS,OSS,OVV,OTV,OTS,TV,TS,TVV,TSS,S :Real;
VPASS,SPASS,VTRY,STRY :Boolean;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
NZ := 0;
BETAV := 0.25;
BETAS := 0.25;
OSS := _PRPQLJ.elm1;
OVV := _PRPQLJ.elm4;
ZRPQLH(_PRPQLJ.elm26,_PRPQLJ.elm3,_PRPQLJ.elm4,RAB[_PP11R.elm2+0],RAB[_PP11R.elm3+0],_PRPQLJ.elm5,_PRPQLJ.elm6);
ZRPQLE(ITYPE,RAB);
for J:=1 to L2 do
 begin
  ZRPQLF(ITYPE,RAB);
  ZRPQLE(ITYPE,RAB);
  ZRPQLG(ITYPE,UI,VI,RAB);
  VV := VI;
  SS := 0.0;
  I1 := _PP11R.elm4+_PRPQLJ.elm25;
  I2 := _PP11R.elm2+_PRPQLJ.elm26;
  if ( RAB[I1-1] <> ZERO ) 
   then SS := -RAB[I2-1]/RAB[I1-1];
  TV := 1.0;
  TS := 1.0;
  if ( J = 1 ) or ( ITYPE = 3 ) 
   then goto _7;
  if ( VV <> 0 ) 
   then TV := Abs((VV-OVV)/VV);
  if ( SS <> 0 ) 
   then TS := Abs((SS-OSS)/SS);
  TVV := 1.0;
  if ( TV < OTV ) 
   then TVV := TV*OTV;
  TSS := 1.0;
  if ( TS < OTS ) 
   then TSS := TS*OTS;
  VPASS := ( TVV < BETAV );
  SPASS := ( TSS < BETAS );
  if ( not ( (SPASS ) or ( VPASS) ) ) 
   then goto _7;
  SVU := _PRPQLJ.elm3;
  SVV := _PRPQLJ.elm4;
  for I:=1 to _PRPQLJ.elm25 do
   begin
    I1 := _PP11R.elm6+I;
    I2 := _PP11R.elm4+I;
_1:
    RAB[I1-1] := RAB[I2-1];
   end;
  S := SS;
  VTRY := False;
  STRY := False;
  if ( SPASS ) and ( (( not VPASS) ) or ( TSS < TVV) ) 
   then goto _4;
_2:
  ZRPQLC(UI,VI,NZ,RAB);
  if ( NZ > 0 ) 
   then goto _9;
  VTRY := True;
  BETAV := BETAV*0.25;
  if ( STRY ) or ( ( not SPASS) ) 
   then goto _5;
  for I:=1 to _PRPQLJ.elm25 do
   begin
    I1 := _PP11R.elm4+I;
    I2 := _PP11R.elm6+I;
_3:
    RAB[I1-1] := RAB[I2-1];
   end;
_4:
  ZRPQLD(S,NZ,IFLAG,RAB);
  if ( NZ > 0 ) 
   then goto _9;
  STRY := True;
  BETAS := BETAS*0.25;
  if ( IFLAG = 0 ) 
   then goto _5;
  UI := -(S+S);
  VI := S*S;
  goto _2;
_5:
  _PRPQLJ.elm3 := SVU;
  _PRPQLJ.elm4 := SVV;
  for I:=1 to _PRPQLJ.elm25 do
   begin
    I1 := _PP11R.elm4+I;
    I2 := _PP11R.elm6+I;
_6:
    RAB[I1-1] := RAB[I2-1];
   end;
  if ( VPASS ) and ( ( not VTRY) ) 
   then goto _2;
  ZRPQLH(_PRPQLJ.elm26,_PRPQLJ.elm3,_PRPQLJ.elm4,RAB[_PP11R.elm2+0],RAB[_PP11R.elm3+0],_PRPQLJ.elm5,_PRPQLJ.elm6);
  ZRPQLE(ITYPE,RAB);
_7:
  OVV := VV;
  OSS := SS;
  OTV := TV;
  OTS := TS;
_8:
 end;
_9:
end;

end.
