Unit ZRPQLD_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZRPQLD(var SSS :Real; var NZ :Integer; var IFLAG :Integer;
                var RAB :Array of Real);

implementation

procedure ZRPQLD(var SSS :Real; var NZ :Integer; var IFLAG :Integer;
                var RAB :Array of Real);
var
NM1,J,I,I1,I2,I3 :Integer;
S,PV,RMP,RMS,EE,T,OMP,RKV :Real;
const
ZERO :Real = 0.0;
PT001 :Real = 0.001;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
NM1 := _PRPQLJ.elm25-1;
NZ := 0;
S := SSS;
IFLAG := 0;
J := 0;
_1:
PV := RAB[_PP11R.elm2+0];
RAB[_PP11R.elm3+0] := PV;
for I:=2 to _PRPQLJ.elm26 do
 begin
  I1 := _PP11R.elm2+I;
  I2 := _PP11R.elm3+I;
  PV := PV*S+RAB[I1-1];
  RAB[I2-1] := PV;
_2:
 end;
RMP := Abs(PV);
RMS := Abs(S);
EE := (_PRPQLJ.elm24/(_PRPQLJ.elm23+_PRPQLJ.elm24))*Abs(RAB[_PP11R.elm3+0]);
for I:=2 to _PRPQLJ.elm26 do
 begin
  I1 := _PP11R.elm3+I;
_3:
  EE := EE*RMS+Abs(RAB[I1-1]);
 end;
if ( RMP > 20.0*((_PRPQLJ.elm23+_PRPQLJ.elm24)*EE-_PRPQLJ.elm24*RMP) ) 
 then goto _4;
NZ := 1;
_PRPQLJ.elm18 := S;
_PRPQLJ.elm19 := ZERO;
goto _12;
_4:
J := J+1;
if ( J > 10 ) 
 then goto _12;
if ( J < 2 ) 
 then goto _5;
if ( Abs(T) > PT001*Abs(S-T) ) or ( RMP <= OMP ) 
 then goto _5;
IFLAG := 1;
SSS := S;
goto _12;
_5:
OMP := RMP;
RKV := RAB[_PP11R.elm4+0];
RAB[_PP11R.elm5+0] := RKV;
for I:=2 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm4+I;
  I2 := _PP11R.elm5+I;
  RKV := RKV*S+RAB[I1-1];
  RAB[I2-1] := RKV;
_6:
 end;
I1 := _PP11R.elm4+_PRPQLJ.elm25;
if ( Abs(RKV) <= Abs(RAB[I1-1])*10.0*_PRPQLJ.elm22 ) 
 then goto _8;
T := -PV/RKV;
RAB[_PP11R.elm4+0] := RAB[_PP11R.elm3+0];
for I:=2 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm4+I;
  I2 := _PP11R.elm5+I-1;
  I3 := _PP11R.elm3+I;
_7:
  RAB[I1-1] := T*RAB[I2-1]+RAB[I3-1];
 end;
goto _10;
_8:
RAB[_PP11R.elm4+0] := ZERO;
for I:=2 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm4+I;
  I2 := _PP11R.elm5+I-1;
_9:
  RAB[I1-1] := RAB[I2-1];
 end;
_10:
RKV := RAB[_PP11R.elm4+0];
for I:=2 to _PRPQLJ.elm25 do
 begin
  I1 := _PP11R.elm4+I;
_11:
  RKV := RKV*S+RAB[I1-1];
 end;
T := ZERO;
I1 := _PP11R.elm4+_PRPQLJ.elm25;
if ( Abs(RKV) > Abs(RAB[I1-1])*10.0*_PRPQLJ.elm22 ) 
 then T := -PV/RKV;
S := S+T;
goto _1;
_12:
end;

end.
