Unit ZRPQLI_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZRPQLI(RA :Real; B1 :Real; C :Real; var SR :Real;
                var SI :Real; var RLR :Real; var RLI :Real);

implementation

procedure ZRPQLI(RA :Real; B1 :Real; C :Real; var SR :Real;
                var SI :Real; var RLR :Real; var RLI :Real);
var
D,E,RB :Real;
const
ZERO :Real = 00.0;
ONE :Real = 1.0;
TWO :Real = 2.0;
label
_10,_20,_30,_40,_50,_60,_70;
begin
if ( RA  <>  ZERO ) 
 then goto _20;
SR  := ZERO;
if ( B1  <>  ZERO ) 
 then SR  := -C/B1;
RLR  := ZERO;
_10:
SI  := ZERO;
RLI  := ZERO;
goto _70;
_20:
if ( C  <>  ZERO ) 
 then goto _30;
SR  := ZERO;
RLR  := -B1/RA;
goto _10;
_30:
RB  := B1/TWO;
if ( Abs(RB) <  Abs(C) ) 
 then goto _40;
E  := ONE - (RA/RB)*(C/RB);
D  := Sqrt(Abs(E))*Abs(RB);
goto _50;
_40:
E  := RA;
if ( C  <  ZERO ) 
 then E  := -RA;
E  := RB*(RB/Abs(C)) - E;
D  := Sqrt(Abs(E))*Sqrt(Abs(C));
_50:
if ( E  <  ZERO ) 
 then goto _60;
if ( RB  >=  ZERO ) 
 then D  := -D;
RLR  := (-RB + D)/RA;
SR  := ZERO;
if ( RLR  <>  ZERO ) 
 then SR  := (C/RLR)/RA;
goto _10;
_60:
SR  := -RB/RA;
RLR  := SR;
SI  := Abs(D/RA);
RLI  := -SI;
_70:
end;

end.
